#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Download.ico
#AutoIt3Wrapper_UseUpx=y
#AutoIt3Wrapper_Change2CUI=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Inet.au3>
#include <File.au3>
#include <WinAPI.au3>
If $CmdLine[0] = 0 Then
	$dll = DllOpen("Kernel32.dll") ;Open Kernel32.dll because we will be using it a lot
	$hnd = _WinAPI_GetStdHandle(1) ;Get the AutoIt process's standard output handle
	_WinAPI_SetConsoleTextAttribute($hnd, "11", $dll)
	ConsoleWrite(@CRLF & _
	'         ************************************************************************************************'& @CRLF & _
	'            Extrenal Command Line for downloading files from internet written in Autoit by Hackoo 2018'   & @CRLF & _
	'         ************************************************************************************************'& @CRLF & _
	'            Usage : ' & @ScriptName & ' ' & chr(34) & "[Link]" & chr(34) & " Optional " & chr(34) & "[FileName]" & chr(34))
	Sleep(8000)
	Exit
Else
	_DownloadWithProgress($CmdLine[1], "")
EndIf
;-----------------------------------------------------------------------------------------------------------------------------------------------------------
Func _DownloadWithProgress($sURL, $sFileName = "")
	Local $hDownload, $iSizeBytes = InetGetSize($sURL)
	Local $iH, $iM, $iS, $iTicks, $iCompletedBytes, $nPercent, $nElapsedTime, $nBPS, $nT = TimerInit()
	If $sFileName = "" Then
		If CheckDirectLink($sURL) = 1 Then
			$hDownload = InetGet($sURL, StringTrimLeft($sURL, StringInStr($sURL, "/", 0, -1)), 1, 1)
		Else
			$sURL = _GetHeaderLocation($sURL)
			$hDownload = InetGet($sURL, StringTrimLeft($sURL, StringInStr($sURL, "/", 0, -1)), 1, 1)
		EndIf
	Else
		$hDownload = InetGet($sURL, $sFileName, 0, 1)
	EndIf
	ProgressOn(" Download is in progress . . . .  ", "0% done - 0 Kb/s", "Remaining time - 00:00:00", Default, Default, 18)
	Do
		$iCompletedBytes = InetGetInfo($hDownload, 0)
		$nPercent = $iCompletedBytes * 100 / $iSizeBytes
		$nElapsedTime = TimerDiff($nT) / 1000
		$nBPS = $iCompletedBytes / $nElapsedTime
		$iTicks = $iSizeBytes / $nBPS - $nElapsedTime
		$iH = Int($iTicks / 3600)
		$iTicks = Mod($iTicks, 3600)
		$iM = Int($iTicks / 60)
		$iS = Mod($iTicks, 60)
		ProgressSet($nPercent, "Remaining - " & StringFormat("%02d:%02d:%02d", $iH, $iM, $iS), StringFormat("%.1f", Round($nPercent, 1)) & "% done ! " & Int($nBPS / 1024) & " Kb/s")
		Sleep(50)
	Until InetGetInfo($hDownload, 2)
	ProgressSet(100, "", "The download is complete !")
	Sleep(3000)
	ProgressOff()
EndFunc   ;==>_DownloadWithProgress
;-----------------------------------------------------------------------------------------------------------------------------------------------------------
; #FUNCTION# ====================================================================================================================
; Name...........: _WinAPI_SetConsoleTextAttribute
; Description ...: Changes the text and/or background color of text in the Windows console.
; Syntax.........: _WinAPI_SetConsoleTextAttribute($hConsole, $iColor, $hDLL = "Kernel32.dll")
; Parameters ....: $hConsole    - Handle to the console screen buffer
;                  $iColor      - Color style to apply to the console.
;                  $hDLL        - Handle to the DLL to call. (Leave blank to open Kernel32.dll each call)
; Return values .: Success      - True
;                  Failure      - False
; Author ........: Ken Piper (Kealper)
; Modified.......:
; Remarks .......:
; Related .......:
; Link ..........: @@MsdnLink@@ SetConsoleTextAttribute
; Example .......:
; ===============================================================================================================================
Func _WinAPI_SetConsoleTextAttribute($hConsole, $iColor, $hDLL = "Kernel32.dll")
	$ret = DllCall($hDLL, "BOOL", "SetConsoleTextAttribute", "HANDLE", $hConsole, "WORD", $iColor)
	If @error Then Return SetError(@error, @extended, False)
	Return $ret[0]
EndFunc   ;==>_WinAPI_SetConsoleTextAttribute
;===============================================================================================================================
Func _GetHeaderLocation($sURL)
;https://stackoverflow.com/questions/32655302/how-to-get-http-response-header-in-vbscript?answertab=active#tab-top
Const $WHR_EnableRedirects = 6
Local $oHTTP = ObjCreate("winhttp.winhttprequest.5.1")
If Not @error Then
	$oHTTP.Option($WHR_EnableRedirects) = False ;disable redirects
    $oHTTP.Open("HEAD",$sURL, False)
    $oHTTP.Send
	$GetLocation = $oHTTP.GetResponseHeader("Location") ;an error occurs if not exist
	Return $GetLocation
EndIf
EndFunc
;===============================================================================================================================
Func CheckDirectLink($url)
	Local $Pattren = "(?i)(.exe|.zip|.rar|.msi|.vbs|.bat|.hta|.txt|.log|.doc" & _
	"|.docx|.xls|.xlsx|.pdf|.mp3|.mp4|.avi|.png|.jpg|.jpeg|.bmp|.gif)"
	Local $return = StringRegExp($url,$Pattren,"",1)
	Return $return
EndFunc
;===============================================================================================================================